/*********************************************************
*Copyright (C), 2020, Shanghai Eastsoft Microelectronics Co., Ltd
*ļ:  adc_offset.c
*  :  AE Team
*  :  v1.0iDesigner(v4.2.3.166) + HRCC(v1.2.0.106)
*  :  2020/12/25
*  :  ADCͨʾ
          PA7ģ˿
          PB5TX
          PB6RX
          תADֵͨڷ͵λ9600bps궨VDDVREFѡVDDΪοѹˣ
          ѡڲ2.048VΪοѹˡ
		  תֵȥoffsetADCoffsetΪ802FHڲ2.048Vο8030HVDDο8λݣ
		  IAP16λݺжǷߵ8λȡ
		  ע⣺offsetĴڣΪֹתֵСoffsetʱADCֱӹ0ADCֻܲ⵽(0xFFF-offset)
*  ע:  ѧϰʾʹãûֱôķջеκηΡ
**********************************************************/
#include <hic.h>

#define VDDVREF        //궨ѡVDDΪοѹעͱѡڲ2.048VΪοѹ
#define CLRWDT()   {__Asm CWDT;}        //궨幷ָ

typedef unsigned char uchar;
typedef unsigned int uint;

uint adc_value;
uint offset_value = 0;  //ADCУ׼ֵ
uchar str[] = "ͨ תֵΪ:    \r\n\0";

/******************************************************
void RAMclear(void)
  RAM㣬RAMַ0x0000~0x03FF
ֵ
ֵ
ֵ
*******************************************************/
void RAMclear(void)
{
    for (IAAH=0; IAAH<=0x03; IAAH++)
    {
        for (IAAL=0; IAAL<0xFF; IAAL++)
            IAD = 0x00;
        IAD = 0x00;
    }
}

/******************************************************
void GPIOInit(void)
  ȳʼδõIOΪ͵ƽ
ֵ
ֵ
ֵ
*******************************************************/
void GPIOInit(void)
{
    ANSH = 0xFF;        //ѡӦ˿ΪIO
    ANSL = 0xFF;        //ѡӦ˿ΪIO
    PAT = 0x00;         //IOΪ͵ƽ
    PBT = 0x00;
    PCT = 0x00;
    PA = 0x00;
    PB = 0x00;
    PC = 0x00;
}

/**********************************************
UART_send(uchar *str,uchar ch,uint value)
  UARTͺ
ֵַָ룬ͨADCתֵ
ֵ
ֵ
**********************************************/
void UART_send(uchar *str,uchar ch,uint value)
{
    *(str+4) = ch+'0';
    *(str+16) = value/1000+'0';
    *(str+17) = value%1000/100+'0';
    *(str+18) = value%100/10+'0';
    *(str+19) = value%10+'0';

    while(*str)
    {
        while(!TRMT1);
        TX1B = *str++;
    }
}

/**********************************************
ADC_convert(uchar ch)
  ADCת
ֵתͨch
ֵ
ֵת12λ
**********************************************/
uint ADC_convert(void)
{
    ADTRG = 1;      //ADת
    while(ADTRG);
    ADIF = 0;

    return (uint)ADCRH<<8 | ADCRL;
}

/*******************************************************
uint GetOffset2048(void)
  ȡοѹΪڲ2.048Vʱoffsetֵ
ֵ
ֵ
ֵoffsetֵ
*******************************************************/
uint GetOffset2048(void)
{
	uint value_tmp = 0;
	unsigned char gie_bk = GIE;		//GIE

    CLRWDT();

	while(GIE) GIE = 0;
	DATARDEN = 1;

	FRAH = 0x802F >> 8;
	FRAL = 0x802F;
	DATARDTRG = 1;
	while(DATARDTRG) ;	     //ȴ
	__Asm TBR;		         //ָ
	value_tmp = (ROMDH<<8) | ROMDL;

    ROMCL = 0x00;            //˳IAP
	GIE = gie_bk;            //ָȫж

	return value_tmp;
}

/*******************************************************
uint GetOffsetVDD(void)
  ȡοѹΪVDDʱoffsetֵ
ֵ
ֵ
ֵoffsetֵ
*******************************************************/
uint GetOffsetVDD(void)
{
	uint value_tmp = 0;
	unsigned char gie_bk = GIE;		//GIE

    CLRWDT();

	while(GIE) GIE = 0;
	DATARDEN = 1;

	FRAH = 0x8030 >> 8;
	FRAL = 0x8030;
	DATARDTRG = 1;
	while(DATARDTRG) ;	     //ȴ
	__Asm TBR;		         //ָ
	value_tmp = (ROMDH<<8) | ROMDL;

    ROMCL = 0x00;            //˳IAP
	GIE = gie_bk;            //ָȫж

    return value_tmp;
}

/**********************************************
main()
  ,ѡAIN7ֵͨUART͵λ
ֵ
ֵ
ֵ
**********************************************/
void main(void) 
{
    uint i = 800;         //ʱ
    uint j = 3000;        //ʱ
	uchar cnt = 3;

//    RAMclear();
    CLRWDT();
	GPIOInit();

/****************ʼUART*******************/
    PBT5 = 0;       //TX
    PBT6 = 1;       //RX
    TX1LEN = 0;     //8λݷ͸ʽ
    BRGH1 = 0;      //ʵģʽ=Fosc/(64*(BRR<7:0>+1))
    BR1R = 25;      //=16MHz/(64*26)9600bps
     
/****************ʼADC********************/
#ifdef VDDVREF
	while(cnt != 0)
	{
        offset_value = GetOffsetVDD();  //ȡoffsetֵ
		if((offset_value>>8) == ((~offset_value) & 0x00FF)) //ǷߵͰλȡȡ8λΪoffset
		{
			offset_value =  offset_value & 0x00FF;

			break;
		}
		else
		{
		    cnt--;

			if(cnt == 0)
			    offset_value = 0;  //IAP3κԲߵ8λȡoffset̶Ϊ0
		}
	}
    ANSL7 = 0;          //ѡAIN7Ϊģ
    ADCCL |= 0xF0;      //ADCCL<7:4>ѡͨ
    ADCCL &= 0x7F;      //ѡͨ7
	ADCCM = 0x4B;       //οԴVDD,ο̶ѡVSSתλ̶ѡ12λADoffset̶ѡλ1
    ADCCH = 0xC8;       //λ;ʱFOSC/16
#else
	while(cnt != 0)
	{
        offset_value = GetOffset2048();  //ȡoffsetֵ
		if((offset_value>>8) == ((~offset_value) & 0x00FF)) //ǷߵͰλȡȡ8λΪoffset
		{
			offset_value =  offset_value & 0x00FF;

			break;
		}
		else
		{
		    cnt--;

			if(cnt == 0)
			    offset_value = 0;    //IAP3κԲߵ8λȡoffset̶Ϊ0
		}
	}
    ANSL7 = 0;          //ѡAIN7Ϊģ
    ADCCL |= 0xF0;      //ADCCL<7:4>ѡͨ
    ADCCL &= 0x7F;      //ѡͨ7
	ADCCM = 0x6B;       //οԴڲ̶ѡ2.048V,ο̶ѡVSSתλ̶ѡ12λADoffset̶ѡλ1
    ADCCH = 0xC8;       //λ;ʱFOSC/16
    VREFEN = 1;         //οѹģʹ
	while(j--);         //ȴ300us
	VREF_CHOPEN = 1;    //ڲοʹܵѹն
#endif

	ADC_LP_EN = 1;      //ADC͹ı̶ʹ
    PAT7 = 1;
    SMPS = 1;           //ӲƲADTRG=1ʱADת
    ADEN = 1;           //ʹADCģ
    while(i--);         //ʹADڵһת֮ǰʱ80us

    ADC_convert();      //״תֵ׼ȷ

    while(1)
    {
		adc_value = ADC_convert();

		if(adc_value > offset_value)   //ADתֵoffsetֵȥoffsetADC0
		    adc_value -= offset_value;
		else
		    adc_value = 0;

		TX1EN = 1;      //򿪷
        UART_send(str,7,adc_value);
        for(i = 0;i<50000;i++);        //ʱ
        for(i = 0;i<50000;i++);
        for(i = 0;i<50000;i++);
        for(i = 0;i<50000;i++);
        for(i = 0;i<50000;i++);
        for(i = 0;i<50000;i++);
        TX1EN = 0;      //رշ

        CLRWDT();
    }
}